//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <iostream>
#include <exception>

using namespace std;

#include <exception>
#include <math>
#include "uMain.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TColors *Colors;
//---------------------------------------------------------------------------
__fastcall TColors::TColors(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
	const MaxSpectrum = 1529;
//	enum U1 {u1Min = 0, u1Max = 255};
	typedef unsigned char U1;
	typedef unsigned short int U2;
	typedef unsigned long int U4;
	typedef signed char S1;
	typedef signed short int S2;
	typedef signed long int S4;
	typedef __int64 S8;


	enum THue {huMin = -1, huMax = MaxSpectrum};

//	typedef TRGB* PRGB;
/*	union TRGB { // RGB=3
		U1 R, G, B;
		U1 I[3];
		U2 RG;
	};*/
//	PRGBA = ^TRGBA;
	struct TRGBA { // RGBA=4
		U1 R, G, B, A;
/*		S4 L;
		U1 I[4];
		U2 RG, BA;*/
	};
	// 4 U1 for CPU
//	PRColor = PRGBA;

	struct THLS {// 4
		THue H; //Hue; // 2
		U1 L; //Lightness; // 1
		U1 S; //Saturation; // 1
	};

	struct TCMYK { // 4
		U1 C, M, Y, K;
	};

// Converts

int RoundDiv(int Dividend, int Divisor) {
// 0 div 4 is 0
// 1 div 4 is 0
// 2 div 4 is 1
// 3 div 4 is 1
	int Result;
	if (Dividend < 0)
		Result = (Dividend - (Divisor / 2)) / Divisor;
	else
		Result = (Dividend + (Divisor / 2)) / Divisor;
	return Result;
}

THLS RGBToHLS(TRGBA C) {
int maxC, minC, delta, H;
	THLS Result;

	Result.H = -1;
	Result.L = 0;
	Result.S = 0;

	maxC = max(max(C.R, C.G), C.B);
	minC = min(min(C.R, C.G), C.B);

	Result.L = (maxC + minC) / 2;

	delta = maxC - minC;
	if (delta == 0)
	{
		Result.S = 0;
		Result.H = -1;
	}
	else
	{
		if (Result.L < 128)
			Result.S = RoundDiv(255 * delta, (maxC + minC));
		else
			Result.S = RoundDiv(255 * delta, (2 * 255 - maxC - minC));

		H = 0;
		if (C.R == maxC)
			H = ((MaxSpectrum + 1) / 6) * (C.G - C.B) / delta;
		else if (C.G == maxC)
			H = ((MaxSpectrum + 1) / 6) * 2 + RoundDiv(((MaxSpectrum + 1) / 6) * (C.B - C.R), delta);
		else if (C.B == maxC)
			H = ((MaxSpectrum + 1) / 6) * 4 + RoundDiv(((MaxSpectrum + 1) / 6) * (C.R - C.G), delta);
		if (H < 0) H += (MaxSpectrum + 1);
		Result.H = H;
	}
	return Result;
}

U1 HLSRGBValue(int n1, int n2, int hue) {
	U1 Result;
	if(hue >= (MaxSpectrum + 1))
		hue -= (MaxSpectrum + 1);
	else if (hue < 0)
		hue += (MaxSpectrum + 1);
	if (hue < ((MaxSpectrum + 1) / 6))
		Result = RoundDiv(n1+(n2-n1)*hue / ((MaxSpectrum + 1) / 6), 255);
	else if (hue < ((MaxSpectrum + 1) / 2))
		Result = RoundDiv(n2, 255);
	else if (hue < (2 * (MaxSpectrum + 1) / 3))     //  n1+(n2-n1)*(240-hue)/60;
		Result = RoundDiv(n1+(n2-n1)*(2 * (MaxSpectrum + 1) / 3-hue) / ((MaxSpectrum + 1) / 6), 255);
	else
		Result = RoundDiv(n1, 255);
	return Result;
}

//class EBadParams : public ERangeError {};

TRGBA HLSToRGB(THLS C) {
int m2, m1;
	TRGBA Result;

	Result.R = 0;
	Result.G = 0;
	Result.B = 0;
	Result.A = 0;

	if (C.L < 128)
		m2 = C.L * (255 + C.S);
	else
		m2 = 255 * (C.L + C.S) - C.L * C.S;
	m1 = 2 * 255 * C.L - m2;
	if (C.S == 0)
	{
		Result.R = C.L;
		Result.G = C.L;
		Result.B = C.L;
		if (C.H != -1) throw ERangeError("Invalid Hue");
	}
	else
	{
		Result.R = HLSRGBValue(m1, m2, C.H + ((MaxSpectrum + 1) / 3));
		Result.G = HLSRGBValue(m1, m2, C.H);
		Result.B = HLSRGBValue(m1, m2, C.H - ((MaxSpectrum + 1) / 3));
		if (C.H == -1) throw ERangeError("Invalid Hue");
	}
	return Result;
}

TRGBA CMYKToRGB(TCMYK C) {
	TRGBA Result;

	Result.R = 0;
	Result.G = 0;
	Result.B = 0;
	Result.A = 0;

	Result.R = 255 - C.C - C.K;
	Result.G = 255 - C.M - C.K;
	Result.B = 255 - C.Y - C.K;

	return Result;
}

TCMYK RGBToCMYK(TRGBA C) {
	TCMYK Result;

	Result.C = 0;
	Result.M = 0;
	Result.Y = 0;
	Result.K = 0;

	Result.C = 255 - C.R;
	Result.M = 255 - C.G;
	Result.Y = 255 - C.B;
	Result.K = min(min(Result.C, Result.M), Result.Y);
	Result.C -= Result.K;
	Result.M -= Result.K;
	Result.Y -= Result.K;

	return Result;
}

int OutputFormat;

//---------------------------------------------------------------------------
class TBColor {
	private:

	protected:
		U1 FR, FG, FB, FA;

	public:
		TBColor() { FR = 0; FG = 0; FB = 0; }
		TBColor(U1 R, U1 G, U1 B, U1 A);
		TBColor(U1 R, U1 G, U1 B);
		virtual TBColor Plus(TBColor C);
		virtual TBColor operator+(TBColor C);
		virtual TBColor operator&(TBColor C);
		virtual TBColor operator|(TBColor C);
//		virtual TBColor operator-(TBColor C);
		TBColor operator-();
		TBColor operator*(TBColor C);
	friend TBColor operator-(TBColor C, TBColor D);
//	TBColor operator=(TBColor);
	int ToInt();
	operator const int () {return ToInt();}
		U1 GetR() { return FR; }
		U1 GetG() { return FG; }
		U1 GetB() { return FB; }
		U1 GetA() { return FA; }
	virtual AnsiString ToString() { return "N/A"; }
	virtual void Update() { };
};

TBColor::TBColor(U1 R, U1 G, U1 B, U1 A)
{
	FR = R;
	FG = G;
	FB = B;
	FA = A;
}

TBColor::TBColor(U1 R, U1 G, U1 B)
{
	FR = R;
	FG = G;
	FB = B;
	FA = 0;
}

TBColor TBColor::Plus(TBColor C)
{
	return TBColor(
		U1((FR + C.FR) / 2),
		U1((FG + C.FG) / 2),
		U1((FB + C.FB) / 2),
		U1((FA + C.FA) / 2));
}

TBColor TBColor::operator+(TBColor C)
{
	return TBColor(
		U1((FR + C.FR) / 2),
		U1((FG + C.FG) / 2),
		U1((FB + C.FB) / 2),
		U1((FA + C.FA) / 2));
}

TBColor TBColor::operator&(TBColor C)
{
	return TBColor(
		U1((FR & C.FR)),
		U1((FG & C.FG)),
		U1((FB & C.FB)),
		U1((FA & C.FA)));
}

TBColor TBColor::operator|(TBColor C)
{
	return TBColor(
		U1((FR | C.FR)),
		U1((FG | C.FG)),
		U1((FB | C.FB)),
		U1((FA | C.FA)));
}

TBColor TBColor::operator-()
{
	return TBColor(
		U1((255 - FR)),
		U1((255 - FG)),
		U1((255 - FB)),
		U1((255 - FA)));
}

TBColor operator-(TBColor C, TBColor D)
{
	return TBColor(
		U1(max(0, C.FR - D.FR)),
		U1(max(0, C.FG - D.FG)),
		U1(max(0, C.FB - D.FB)),
		U1(max(0, C.FA - D.FA)));
}

TBColor TBColor::operator*(TBColor C)
{
	return TBColor(
		U1((FR * C.FR) / 255),
		U1((FG * C.FG) / 255),
		U1((FB * C.FB) / 255),
		U1((FA * C.FA) / 255));
}

int TBColor::ToInt()
{
	return (FR + (int(FG) << 8) + (int(FB) << 16) + (int(FA) << 24));
}

TBColor *CInp[2];

//---------------------------------------------------------------------------
class TDColor : public TBColor {
	private:
//		U1 FR, FG, FB, FA;
	protected:
	public:
		TDColor(U1 R, U1 G, U1 B, U1 A);
		TDColor(U1 R, U1 G, U1 B);
		TDColor(TColor C);
//		TDColor(TDColor C2);
		TDColor();
		~TDColor();
		int ToInt();
		TRGBA GetRGBA();
		U1 GetR() { return FR; }
		U1 GetG() { return FG; }
		U1 GetB() { return FB; }
		U1 GetA() { return FA; }
		AnsiString ToString();

		TDColor operator=(TBColor C) { return TDColor(C.GetR(), C.GetG(), C.GetB()); };
		virtual TDColor Plus(TDColor C);
		virtual TDColor operator+(TDColor C);
		TDColor operator-();
		operator const int () {return ToInt();}
		friend TDColor operator-(TDColor C, TDColor D);
		virtual void Update() { };
};

int TDColor::ToInt()
{
	return (FR + (int(FG) << 8) + (int(FB) << 16) + (int(FA) << 24));
}

TRGBA TDColor::GetRGBA()
{
	TRGBA C;
	C.R = FR;
	C.G = FG;
	C.B = FB;
	C.A = FA;

	return C;
}

/*TRColor::operator int ();
{
	return L();
}*/

TDColor::TDColor(U1 R, U1 G, U1 B, U1 A)
{
	FR = R;
	FG = G;
	FB = B;
	FA = A;
}

TDColor::TDColor(U1 R, U1 G, U1 B)
{
	FR = R;
	FG = G;
	FB = B;
	FA = 0;
}

TDColor::TDColor(TColor C)
{
	FR = C & 0xff;
	FG = (C >> 8) & 0xff;
	FB = (C >> 16) & 0xff;
	FA = 0;
}

/*
TDColor::TDColor(TDColor C)
{
	FR = C && 0xff;
	FG = (C << 8) && 0xff;
	FB = (C << 16) && 0xff;
	FA = 0;
} */

TDColor::TDColor()
{
	TDColor(0, 0, 0, 0);
}

TDColor::~TDColor()
{
	FR = 0;
	FG = 0;
	FB = 0;
	FA = 0;
}

TDColor TDColor::Plus(TDColor C)
{
	return TDColor(
		U1((FR + C.FR) / 2),
		U1((FG + C.FG) / 2),
		U1((FB + C.FB) / 2),
		U1((FA + C.FA) / 2));
}

TDColor TDColor::operator+(TDColor C)
{
	return TDColor(
		U1((FR + C.FR) / 2),
		U1((FG + C.FG) / 2),
		U1((FB + C.FB) / 2),
		U1((FA + C.FA) / 2));
}

TDColor TDColor::operator-()
{
	return TDColor(
		U1((255 - FR)),
		U1((255 - FG)),
		U1((255 - FB)),
		U1((255 - FA)));
}

/*
TDColor operator-(TDColor C, TDColor D)
{
	return TDColor(
		U1(max(0, C.FR - D.FR)),
		U1(max(0, C.FG - D.FG)),
		U1(max(0, C.FB - D.FB)),
		U1(max(0, C.FA - D.FA)));
}
*/

AnsiString TDColor::ToString()
{
	TVarRec args[4] = {FR, FG, FB, FA};
	if (OutputFormat == 0)
		return Format("RGBA: %d,%d,%d,%d", args, sizeof(args));
	else if (OutputFormat == 1)
		return Format("RGBA: 0x%x,0x%x,0x%x,0x%x", args, sizeof(args));
	else
	{
		return ColorToString(ToInt());
	}
}

//---------------------------------------------------------------------------
class THLSColor : public TBColor {
	private:
		THue FH;
		U1 FL, FS;
	public:
/*		HLSColor(U1 H, U1 L, U1 S, U1 A = 0);
		HLSColor(TRColor C);*/
		THLSColor() { FH = 0; FL = 0; FS = 0; }
		THLSColor(THLS C);
		THLSColor(THue H, U1 L, U1 S);
		THLSColor(TColor C);

		THue GetH() { return FH; }
		U1 GetL() { return FL; }
		U1 GetS() { return FS; }

		THLSColor operator+(THLSColor C);
		AnsiString ToString();
		virtual void Update();
};

AnsiString THLSColor::ToString()
{
	TVarRec args[3] = {FH, FL, FS};
	if (OutputFormat == 0)
		return Format("HLS: %d,%d,%d", args, sizeof(args));
	else if (OutputFormat == 1)
		return Format("HLS: 0x%x,0x%x,0x%x", args, sizeof(args));
	else
	{
		return ColorToString(ToInt());
	}
}

THLSColor::THLSColor(THLS C)
{
	FH = C.H;
	FL = C.L;
	FS = C.S;
	TRGBA RGBA;
	try
	{
		RGBA = HLSToRGB(C);
	}
	catch(int E)
	{
		RGBA.R = 0;
		RGBA.G = 0;
		RGBA.B = 0;
		RGBA.A = 0;
	}
	FR = RGBA.R;
	FG = RGBA.G;
	FB = RGBA.B;
	FA = RGBA.A;
};

THLSColor::THLSColor(THue H, U1 L, U1 S)
{
	THLS C;
	C.H = H;
	C.L = L;
	C.S = S;
//	THLSColor(C); DNW
	FH = C.H;
	FL = C.L;
	FS = C.S;
	TRGBA RGBA;
	try
	{
		RGBA = HLSToRGB(C);
	}
	catch(int E)
	{
		RGBA.R = 0;
		RGBA.G = 0;
		RGBA.B = 0;
		RGBA.A = 0;
	}
	FR = RGBA.R;
	FG = RGBA.G;
	FB = RGBA.B;
	FA = RGBA.A;
};

void THLSColor::Update() {
	TRGBA RGB;
	RGB.R = FR;
	RGB.G = FG;
	RGB.B = FB;
	RGB.A = FA;

	THLS HLS;
	HLS = RGBToHLS(RGB);
	FH = HLS.H;
	FL = HLS.L;
	FS = HLS.S;
}

THLSColor::THLSColor(TColor C) {
	FR = C & 0xff;
	FG = (C >> 8) & 0xff;
	FB = (C >> 16) & 0xff;
	FA = 0;

	TRGBA RGB;
	RGB.R = FR;
	RGB.G = FG;
	RGB.B = FB;
	RGB.A = FA;

	THLS HLS;
	HLS = RGBToHLS(RGB);
	FH = HLS.H;
	FL = HLS.L;
	FS = HLS.S;
}

THLSColor THLSColor::operator+(THLSColor C)
{
	return THLSColor(
		THue((FH + C.FH) / 2),
		U1((FL + C.FL) / 2),
		U1((FS + C.FS) / 2));
}

//---------------------------------------------------------------------------
class TCMYKColor : public TBColor {
	private:
		U1 FC, FM, FY, FK;
	public:
		TCMYKColor() { FC = 0; FM = 0; FY = 0; FK = 0; }
		TCMYKColor(TCMYK C);
		TCMYKColor(TColor C);

		U1 GetC() { return FC; }
		U1 GetM() { return FM; }
		U1 GetY() { return FY; }
		U1 GetK() { return FK; }

		AnsiString ToString();
		virtual void Update();
};

AnsiString TCMYKColor::ToString()
{
	TVarRec args[4] = {FC, FM, FY, FK};
	if (OutputFormat == 0)
		return Format("CMYK: %d,%d,%d,%d", args, sizeof(args));
	else if (OutputFormat == 1)
		return Format("CMYK: 0x%x,0x%x,0x%x,0x%x", args, sizeof(args));
	else
	{
		return ColorToString(ToInt());
	}
}

TCMYKColor::TCMYKColor(TCMYK C)
{
	FC = C.C;
	FM = C.M;
	FY = C.Y;
	FK = C.K;
	TRGBA RGBA;
	try
	{
		RGBA = CMYKToRGB(C);
	}
	catch(int E)
	{
		RGBA.R = 0;
		RGBA.G = 0;
		RGBA.B = 0;
		RGBA.A = 0;
	}
	FR = RGBA.R;
	FG = RGBA.G;
	FB = RGBA.B;
	FA = RGBA.A;
};

void TCMYKColor::Update() {
	TRGBA RGB;
	RGB.R = FR;
	RGB.G = FG;
	RGB.B = FB;
	RGB.A = FA;

	TCMYK CMYK;
	CMYK = RGBToCMYK(RGB);
	FC = CMYK.C;
	FM = CMYK.M;
	FY = CMYK.Y;
	FK = CMYK.K;
}

TCMYKColor::TCMYKColor(TColor C) {
	FR = C & 0xff;
	FG = (C >> 8) & 0xff;
	FB = (C >> 16) & 0xff;
	FA = 0;

	Update();
}

//---------------------------------------------------------------------------
void SetPanel(TPanel *P, TBColor *C)
{
	P->Color = C->ToInt();
	TVarRec args[4] = {C->GetR(), C->GetG(), C->GetB(), C->GetA()};
	if (OutputFormat == 0)
		P->Caption = Format("RGBA: %d,%d,%d,%d", args, sizeof(args));
	else if (OutputFormat == 1)
		P->Caption = Format("RGBA: 0x%x,0x%x,0x%x,0x%x", args, sizeof(args));
	else
	{
		P->Caption = ColorToString(C->ToInt());
	}
	P->Font->Color = (~P->Color) & 0xFFFFFF;
}

//---------------------------------------------------------------------------

void __fastcall TColors::Calc()
{
//	HLSColor *y = new HLSColor(clRed);
	TBColor *COut;
	TBColor *C1;
	TBColor *C2;
	switch (ComboBoxT->ItemIndex) {
	case 2:
	{
		C1 = new TCMYKColor(Panel1->Color);
		C2 = new TCMYKColor(Panel2->Color);
		COut = new TCMYKColor;
		break;
	}
	case 1:
	{
/*		HLSColor CX(Panel1->Color);
		HLSColor CY(Panel2->Color);
		COut = CX + CY;*/
		C1 = new THLSColor(Panel1->Color);
		C2 = new THLSColor(Panel2->Color);
		COut = new THLSColor;
		break;
	}
	default:
	{
		C1 = new TDColor(Panel1->Color);
		C2 = new TDColor(Panel2->Color);
		COut = new TDColor;
/*		TDColor C1(Panel1->Color);
		TDColor C2(Panel2->Color);*/
	}
	}

	switch (ComboBoxO->ItemIndex) {
	case 0:
	{
		*COut = *C1 + *C2;
		break;
	}
	case 1:
	{
		*COut = *C1 - *C2;
		break;
	}
	case 2:
	{
		*COut = *C1 * *C2;
		break;
	}
	case 3:
	{
		*COut = *C1 & *C2;
		break;
	}
	case 4:
	{
		*COut = *C1 | *C2;
		break;
	}
	default:
	{
//		*COut = clBlack;
	}
	}
	COut->Update();

	SetPanel(PanelOut, COut);
	PanelOut->Caption = COut->ToString();

/*	switch (ComboBoxT->ItemIndex) {
	case 1:
	{
		THLSColor* DHLSColor = ((THLSColor*)COut);
//		DHLSColor = COut;
//	int a = ->GetH();
//((HLSColor*)COut)->
		Edit->Text =
			"Hue: " + IntToStr(DHLSColor->GetH()) +
			", Lum: " + IntToStr(DHLSColor->GetL()) +
			", Sat: " + IntToStr(DHLSColor->GetS());
	}
	}*/
}


void __fastcall TColors::PanelXClick(TObject *Sender)
{
	TPanel* P = (TPanel*)Sender;
	ColorDialog->Color = P->Color;
	if (ColorDialog->Execute())
	{
		TDColor *C = new TDColor(ColorDialog->Color);
		SetPanel(P, C);
		Calc();
	}
}
//---------------------------------------------------------------------------

void __fastcall TColors::FormCreate(TObject *Sender)
{
	ComboBoxO->ItemIndex = 0;
	ComboBoxT->ItemIndex = 0;
	ComboBoxOF->ItemIndex = 0;
	CInp[0] = new TDColor((TColor)0x0080FF00);
	CInp[1] = new TDColor((TColor)0x00FF8040);
	SetPanel(Panel1, CInp[0]);
	SetPanel(Panel2, CInp[1]);
	Calc();
}
//---------------------------------------------------------------------------
/*
class complex {
public:
double re, im;
complex(double r = 0, double i = 0) : re(r), im(i) {}
};

complex operator+(complex c) {
return complex(re + c.re, im + c.im);

complex operator+(complex c, complex d) {
return complex(c.re + d.re, c.im + d.im);
}

/*template<class T> class DynArray {
private:
	T* First;
public:
	DynArray(Size) {};
	DynArray() {DynArray(0)};
	~DynArray() {SetSize(0)};
	SetSize(int Size) {

} */

void __fastcall TColors::ComboBoxOChange(TObject *Sender)
{
	Calc();
}
//---------------------------------------------------------------------------

void __fastcall TColors::ComboBoxTChange(TObject *Sender)
{
	Calc();
}
//---------------------------------------------------------------------------

void __fastcall TColors::ComboBoxOFChange(TObject *Sender)
{
	OutputFormat = ComboBoxOF->ItemIndex;
	SetPanel(Panel1, CInp[0]);
	SetPanel(Panel2, CInp[1]);
	Calc();
}
//---------------------------------------------------------------------------

